
#include "xorotypes.h"


//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=8+WORD_POSITION, Max=64) Bit width of generated random numbers.
//#define  CONSTANT_A  11   // Passed in as -D gcc parameter.
//#define  CONSTANT_B  2   // Passed in as -D gcc parameter.
//#define  CONSTANT_C  6   // Passed in as -D gcc parameter.
//#define  CONSTANT_D  7   // Passed in as -D gcc parameter.


// Seed the state array.  Seed MUST not be all zero.
static rngword_t  s[2] = {1, 0};



rngword_t  nextrnd( void )
{
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	rngword_t  s0 = s[0];
	rngword_t  s1 = s[1];
#else
	rngword_t  s0 = s[0] & ACCUM_MASK;
	rngword_t  s1 = s[1] & ACCUM_MASK;
#endif
//Output hash (Scrambler)
//	rngword_t  result = rotl( s0 + s1 + (s1 << 2), CONSTANT_D ) + s0;  // Too serial!
	rngword_t  result = rotl( s0 + s1, CONSTANT_D ) + s0 + (s0 << 2);

//Iterator (Engine)
	s1 ^= s0;
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	s[0] = rotl( s0, CONSTANT_A ) ^ s1 ^ (s1 << CONSTANT_B);
#else
	s[0] = rotl( s0, CONSTANT_A ) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
#endif
	s[1] = rotl( s1, CONSTANT_C );


#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return( result );
#else
	return( result & ACCUM_MASK );
#endif
}
